#!/usr/local/bin/perl -w

# include der CGI, CGI-Fehlermodule und LDAP API:
use CGI ':standard',':html3';
#use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP;

# Parameter fuer LDAP Verbindung:
my $ldap_host = "localhost" ;
my $ldap_port = 389 ;
my $ldap_base = "dc=heise, dc=de";
my $dn        = "";
my $pwd       = "" ;


# Neues CGI Object
my $query = new CGI;

# Ausdrucken des Headers mit Document Typ
print $query->header('text/html'),
      $query->start_html(-title=>'Search Form'),
      $query->h1("PerLDAP Search Gateway");

# Query-Block. Falls der Parameter filter definiert ist,
# wird die Query ausgefuehrt:

if ( ($filter=$query->param('filter'))) {

    @attrs = ['uid','cn'];
    $ldap = new Net::LDAP('localhost');
    $ldap->bind() || die "Could not bind to LDAP server" ;
    $mesg = $ldap->search( base => $ldap_base,
                           filter => $filter,
                           attrs => @attrs
                         ) || die "Search Failed";
    &DisplayResult($mesg);
    $ldap->unbind();
} else {
    # Wenn wir keinen Parameter erhalten, heisst dies fuer uns,
    # dass dies der erste Aufruf des Scripts ist.
    my $action = $query->url;
    print $query->startform(-method => 'POST');
    print $query->table(TR(
                           td("Enter LDAP Search Field"),
	                   td(textfield(-name=>'filter',
                                        -default=>"",
                                        -length =>50))
                         ));
    print $query->br();
    print $query->submit(-name=>"submit", -value=>"Search");
    print $query->endform();
}

print $query->end_html();



################################################################################
# Hilfsfunktionen
################################################################################

sub DisplayResult {
    my ( $mesg ) = @_ ;

    if ( ($Number=$mesg->count()) ) {
        for ($i = 0 ; $i < $Number ; $i++ ) {
            my $entry = $mesg->entry($i);
            printf("Distinct Name: %s\n\n",$entry->dn());
            foreach  $attr ($entry->attributes) {
                printf("%s:     %s\n",$attr, $entry->get($attr) );;
            } 
        } 
    } else {
        
        printf("Search did not return any result\n");
    }
}

